/**
  * @file ltc4260.c
  * @author generated by mrt-device utility 
  * @link [https://mrt.readthedocs.io/en/latest/pages/mrtutils/mrt-device.html]
  * @brief Device driver for LTC4260 device
  *
  */


/* Includes ------------------------------------------------------------------*/
#include "ltc4260.h"

/*user-block-top-start*/
/* Private Variables ---------------------------------------------------------*/
/* Private Functions ---------------------------------------------------------*/
/*user-block-top-end*/


/**
 * @brief initializes device
 * @param dev ptr to LTC4260 device
 * @return status 
 */
static mrt_status_t ltc4260_init(ltc4260_t* dev)
{   
    /* Initialize Register Descriptors */
    REG_INIT( dev->mControl , LTC4260_REG_CONTROL_ADDR , uint8_t, REG_PERM_RW , 0x1B  );
    REG_INIT( dev->mAlert , LTC4260_REG_ALERT_ADDR , uint8_t, REG_PERM_RW , 0x00  );
    REG_INIT( dev->mStatus , LTC4260_REG_STATUS_ADDR , uint8_t, REG_PERM_R , 0x00  );
    REG_INIT( dev->mFault , LTC4260_REG_FAULT_ADDR , uint8_t, REG_PERM_RW , 0x00  );
    REG_INIT( dev->mSense , LTC4260_REG_SENSE_ADDR , uint8_t, REG_PERM_RW , 0x00  );
    REG_INIT( dev->mSource , LTC4260_REG_SOURCE_ADDR , uint8_t, REG_PERM_RW , 0x00  );
    REG_INIT( dev->mAdin , LTC4260_REG_ADIN_ADDR , uint16_t, REG_PERM_RW , 0x0000  );


    /*user-block-init-start*/
    /*user-block-init-end*/

    return MRT_STATUS_OK;
}


mrt_status_t ltc4260_init_i2c(ltc4260_t* dev, mrt_i2c_handle_t i2c)
{
    mrt_status_t status;

    status = init_i2c_register_device(&dev->mRegDev, i2c, LTC4260_I2C_ADDRESS, LTC4260_REG_ADDR_SIZE );

    ltc4260_init(dev);


    /*user-block-init-i2c-start*/
    /*user-block-init-i2c-end*/
    
    return status;
}

mrt_status_t ltc4260_test(ltc4260_t* dev)
{
    mrt_status_t status = MRT_STATUS_ERROR;
    /*user-block-test-start*/

    /*user-block-test-end*/
    return status;
}


/*user-block-bottom-start*/

mrt_status_t ltc4260_set_fet(ltc4260_t* dev, uint8_t state)
{
  regdev_write_field(&dev->mRegDev, &dev->mControl, LTC4260_CONTROL_FET_CTRL, (uint32_t) state);
}


mrt_status_t ltc4260_set_i2c_address(ltc4260_t* dev, uint8_t address)
{
    dev->mRegDev.mAddr = address;
    return MRT_STATUS_OK;
}


float ltc4260_get_sense_voltage(ltc4260_t* dev)
{   
    float voltage;
    uint8_t regVal; 

    regVal = ltc4260_read_reg(dev, LTC4260_REG_SENSE_ADDR);

    voltage = (regVal * LTC4260_SENSE_VOLTAGE_LSB_UV) / 1000;

    return voltage;
}

float ltc4260_get_source_voltage(ltc4260_t* dev)
{
    float voltage;
    uint8_t regVal;

    regVal = ltc4260_read_reg(dev, LTC4260_REG_SOURCE_ADDR);
    voltage = regVal * LTC4260_SOURCE_VOTLAGE_LSB_MV;

    return voltage;
}

float ltc4260_get_adin_voltage(ltc4260_t* dev)
{
    float voltage;
    uint8_t regVal;

    regVal = ltc4260_read_reg(dev, LTC4260_REG_ADIN_ADDR);
    voltage = regVal * LTC4260_ADIN_VOLTAGE_LSB_MV;
    return voltage;
}

/*user-block-bottom-end*/
